=== modified file 'drizzled/cursor.cc'
--- drizzled/cursor.cc	2011-03-18 16:32:21 +0000
+++ drizzled/cursor.cc	2011-03-21 17:26:19 +0000
@@ -45,6 +45,7 @@
 #include <drizzled/key.h>
 #include <drizzled/sql_lex.h>
 #include <drizzled/resource_context.h>
+#include <drizzled/statistics_variables.h>
 
 using namespace std;
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2011-03-08 10:16:48 +0000
+++ drizzled/drizzled.cc	2011-03-21 17:26:19 +0000
@@ -71,6 +71,7 @@
 #include <drizzled/show.h>
 #include <drizzled/sql_base.h>
 #include <drizzled/sql_parse.h>
+#include <drizzled/statistics_variables.h>
 #include <drizzled/temporal_format.h> /* For init_temporal_formats() */
 #include <drizzled/tztime.h>
 #include <drizzled/unireg.h>

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2011-02-24 19:13:33 +0000
+++ drizzled/filesort.cc	2011-03-21 17:26:19 +0000
@@ -48,6 +48,7 @@
 #include <drizzled/global_buffer.h>
 #include <drizzled/sort_field.h>
 #include <drizzled/item/subselect.h>
+#include <drizzled/statistics_variables.h>
 
 using namespace std;
 

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2011-03-18 17:31:28 +0000
+++ drizzled/join.cc	2011-03-21 17:26:19 +0000
@@ -65,6 +65,7 @@
 #include <drizzled/item/subselect.h>
 #include <drizzled/my_hash.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 #include <algorithm>
 
 using namespace std;

=== modified file 'drizzled/optimizer/access_method/scan.cc'
--- drizzled/optimizer/access_method/scan.cc	2011-03-15 23:07:12 +0000
+++ drizzled/optimizer/access_method/scan.cc	2011-03-21 17:26:19 +0000
@@ -26,6 +26,7 @@
 #include <drizzled/internal/my_sys.h>
 #include <drizzled/optimizer/access_method/scan.h>
 #include <drizzled/util/test.h>
+#include <drizzled/statistics_variables.h>
 
 using namespace drizzled;
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-03-18 17:31:28 +0000
+++ drizzled/session.cc	2011-03-21 17:26:19 +0000
@@ -72,6 +72,7 @@
 #include <drizzled/sql_base.h>
 #include <drizzled/sql_lex.h>
 #include <drizzled/statement.h>
+#include <drizzled/statistics_variables.h>
 #include <drizzled/table/singular.h>
 #include <drizzled/table_proto.h>
 #include <drizzled/tmp_table_param.h>
@@ -157,16 +158,19 @@
   */
   LEX lex;
   properties_t properties;
+  system_status_var status_var;
   session::TableMessages table_message_cache;
 };
 
 Session::Session(plugin::Client *client_arg, catalog::Instance::shared_ptr catalog_arg) :
   Open_tables_state(refresh_version),
+  impl_(new impl_c),
   mem_root(&main_mem_root),
   query(new std::string),
   _schema(new std::string),
   scheduler(NULL),
   scheduler_arg(NULL),
+  status_var(impl_->status_var),
   lock_id(&main_lock_id),
   thread_stack(NULL),
   _where(Session::DEFAULT_WHERE),
@@ -206,7 +210,6 @@
   m_lip(NULL),
   cached_table(0),
   arg_of_last_insert_id_function(false),
-  impl_(new impl_c),
   _catalog(catalog_arg),
   transaction_message(NULL),
   statement_message(NULL),

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-03-19 18:07:20 +0000
+++ drizzled/session.h	2011-03-21 17:26:19 +0000
@@ -42,7 +42,7 @@
 #include <drizzled/sql_list.h>
 #include <drizzled/sql_error.h>
 #include <drizzled/sql_locale.h>
-#include <drizzled/statistics_variables.h>
+// #include <drizzled/statistics_variables.h>
 #include <drizzled/system_variables.h>
 #include <drizzled/visibility.h>
 #include <drizzled/util/find_ptr.h>
@@ -99,6 +99,7 @@
 class Table_ident;
 class Time_zone;
 class select_result;
+class system_status_var;
 class user_var_entry;
 struct Ha_data;
 
@@ -136,6 +137,10 @@
 
 class DRIZZLED_API Session : public Open_tables_state
 {
+private:
+  class impl_c;
+
+  boost::scoped_ptr<impl_c> impl_;
 public:
   // Plugin storage in Session.
   typedef boost::shared_ptr<Session> shared_ptr;
@@ -324,7 +329,7 @@
 
   drizzle_system_variables variables; /**< Mutable local variables local to the session */
   enum_tx_isolation getTxIsolation();
-  system_status_var status_var;
+  system_status_var& status_var;
 
   THR_LOCK_INFO lock_info; /**< Locking information for this session */
   THR_LOCK_OWNER main_lock_id; /**< To use for conventional queries */
@@ -1439,8 +1444,6 @@
 
   bool arg_of_last_insert_id_function; // Tells if LAST_INSERT_ID(#) was called for the current statement
 private:
-	class impl_c;
-
   bool free_cached_table(boost::mutex::scoped_lock &scopedLock);
   drizzled::util::Storable* getProperty0(const std::string&);
   void setProperty0(const std::string&, drizzled::util::Storable*);
@@ -1451,7 +1454,6 @@
     return not getrusage(RUSAGE_THREAD, &usage);
   }
 
-  boost::scoped_ptr<impl_c> impl_;
   catalog::Instance::shared_ptr _catalog;
 
   /** Pointers to memory managed by the ReplicationServices component */

=== modified file 'drizzled/signal_handler.cc'
--- drizzled/signal_handler.cc	2011-02-17 00:14:13 +0000
+++ drizzled/signal_handler.cc	2011-03-21 17:26:19 +0000
@@ -30,8 +30,8 @@
 #include <drizzled/plugin.h>
 #include <drizzled/plugin/scheduler.h>
 #include <drizzled/current_session.h>
-
 #include <drizzled/util/backtrace.h>
+#include <drizzled/statistics_variables.h>
 
 using namespace drizzled;
 

=== modified file 'drizzled/sql_delete.cc'
--- drizzled/sql_delete.cc	2011-03-15 20:36:12 +0000
+++ drizzled/sql_delete.cc	2011-03-21 17:26:19 +0000
@@ -33,6 +33,7 @@
 #include <drizzled/filesort.h>
 #include <drizzled/sql_lex.h>
 #include <drizzled/diagnostics_area.h>
+#include <drizzled/statistics_variables.h>
 
 namespace drizzled {
 

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2011-03-14 17:27:03 +0000
+++ drizzled/sql_insert.cc	2011-03-21 17:26:19 +0000
@@ -37,9 +37,9 @@
 #include <drizzled/alter_info.h>
 #include <drizzled/sql_parse.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 extern plugin::StorageEngine *heap_engine;
 extern plugin::StorageEngine *myisam_engine;

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2011-03-19 17:01:16 +0000
+++ drizzled/sql_parse.cc	2011-03-21 17:26:19 +0000
@@ -55,6 +55,7 @@
 #include <drizzled/item/subselect.h>
 #include <drizzled/diagnostics_area.h>
 #include <drizzled/table_ident.h>
+#include <drizzled/statistics_variables.h>
 
 #include <limits.h>
 
@@ -67,8 +68,7 @@
 
 extern int base_sql_parse(drizzled::Session *session); // from sql_yacc.cc
 
-namespace drizzled
-{
+namespace drizzled {
 
 /* Prototypes */
 bool my_yyoverflow(short **a, ParserType **b, ulong *yystacksize);

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2011-03-15 23:07:12 +0000
+++ drizzled/sql_update.cc	2011-03-21 17:26:19 +0000
@@ -37,14 +37,14 @@
 #include <drizzled/sql_lex.h>
 #include <drizzled/diagnostics_area.h>
 #include <drizzled/util/test.h>
+#include <drizzled/statistics_variables.h>
 
 #include <boost/dynamic_bitset.hpp>
 #include <list>
 
 using namespace std;
 
-namespace drizzled
-{
+namespace drizzled {
 
 /**
   Re-read record if more columns are needed for error message.

=== modified file 'drizzled/statement/flush.cc'
--- drizzled/statement/flush.cc	2011-03-10 10:44:18 +0000
+++ drizzled/statement/flush.cc	2011-03-21 17:26:19 +0000
@@ -27,9 +27,9 @@
 #include <drizzled/sql_table.h>
 #include <drizzled/plugin/logging.h>
 #include <drizzled/plugin/storage_engine.h>
+#include <drizzled/statistics_variables.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 bool statement::Flush::execute()
 {

=== modified file 'drizzled/statement/select.cc'
--- drizzled/statement/select.cc	2011-03-15 23:55:01 +0000
+++ drizzled/statement/select.cc	2011-03-21 17:26:19 +0000
@@ -22,6 +22,7 @@
 #include <drizzled/session.h>
 #include <drizzled/statement/select.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 
 namespace drizzled {
 namespace statement {

=== modified file 'drizzled/statement/show.cc'
--- drizzled/statement/show.cc	2011-03-15 23:55:01 +0000
+++ drizzled/statement/show.cc	2011-03-21 17:26:19 +0000
@@ -22,6 +22,7 @@
 #include <drizzled/session.h>
 #include <drizzled/statement/show.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 
 namespace drizzled {
 namespace statement {

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2011-03-19 17:01:16 +0000
+++ drizzled/table.cc	2011-03-21 17:26:19 +0000
@@ -47,7 +47,6 @@
 #include <drizzled/internal/m_string.h>
 #include <plugin/myisam/myisam.h>
 #include <drizzled/plugin/storage_engine.h>
-
 #include <drizzled/item/string.h>
 #include <drizzled/item/int.h>
 #include <drizzled/item/decimal.h>
@@ -59,6 +58,7 @@
 #include <drizzled/table_proto.h>
 #include <drizzled/typelib.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 
 using namespace std;
 

=== modified file 'drizzled/table/singular.cc'
--- drizzled/table/singular.cc	2011-02-23 13:15:31 +0000
+++ drizzled/table/singular.cc	2011-03-21 17:26:19 +0000
@@ -27,14 +27,11 @@
 #include <drizzled/session.h>
 #include <plugin/myisam/myisam.h>
 #include <drizzled/plugin/transactional_storage_engine.h>
-
+#include <drizzled/statistics_variables.h>
 #include <drizzled/table.h>
 
-namespace drizzled
-{
-
-namespace table
-{
+namespace drizzled {
+namespace table {
 
 Singular::Singular(Session *session, List<CreateField> &field_list) :
   _share(message::Table::INTERNAL),

=== modified file 'drizzled/transaction_services.cc'
--- drizzled/transaction_services.cc	2011-03-18 16:32:21 +0000
+++ drizzled/transaction_services.cc	2011-03-21 17:26:19 +0000
@@ -71,6 +71,7 @@
 #include <drizzled/plugin/xa_resource_manager.h>
 #include <drizzled/plugin/xa_storage_engine.h>
 #include <drizzled/internal/my_sys.h>
+#include <drizzled/statistics_variables.h>
 
 #include <vector>
 #include <algorithm>
@@ -80,8 +81,7 @@
 using namespace std;
 using namespace google;
 
-namespace drizzled
-{
+namespace drizzled {
 
 /**
  * @defgroup Transactions

=== modified file 'plugin/function_engine/cursor.cc'
--- plugin/function_engine/cursor.cc	2011-03-14 15:00:51 +0000
+++ plugin/function_engine/cursor.cc	2011-03-21 17:26:19 +0000
@@ -25,6 +25,7 @@
 #include <drizzled/internal/my_sys.h>
 #include <drizzled/field/blob.h>
 #include <drizzled/table.h>
+#include <drizzled/statistics_variables.h>
 
 #include <unistd.h>
 #include <fcntl.h>

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2011-03-18 17:35:45 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2011-03-21 17:26:19 +0000
@@ -68,6 +68,7 @@
 #include <drizzled/transaction_services.h>
 #include <drizzled/message/statement_transform.h>
 #include <drizzled/cached_directory.h>
+#include <drizzled/statistics_variables.h>
 
 #include <boost/algorithm/string.hpp>
 #include <boost/program_options.hpp>

=== modified file 'plugin/logging_stats/cumulative_stats.cc'
--- plugin/logging_stats/cumulative_stats.cc	2011-02-17 00:14:13 +0000
+++ plugin/logging_stats/cumulative_stats.cc	2011-03-21 17:26:19 +0000
@@ -28,6 +28,7 @@
  */
 
 #include <config.h>
+#include <drizzled/statistics_variables.h>
 #include "cumulative_stats.h"
 
 using namespace std;

=== modified file 'plugin/logging_stats/logging_stats.cc'
--- plugin/logging_stats/logging_stats.cc	2011-03-14 15:00:51 +0000
+++ plugin/logging_stats/logging_stats.cc	2011-03-21 17:26:19 +0000
@@ -95,6 +95,7 @@
 #include <drizzled/module/option_map.h>
 #include <drizzled/session.h>
 #include <drizzled/sql_lex.h>
+#include <drizzled/statistics_variables.h>
 
 namespace po= boost::program_options;
 using namespace drizzled;

=== modified file 'plugin/logging_stats/scoreboard.cc'
--- plugin/logging_stats/scoreboard.cc	2011-02-17 00:14:13 +0000
+++ plugin/logging_stats/scoreboard.cc	2011-03-21 17:26:19 +0000
@@ -46,6 +46,7 @@
 
 #include <config.h>
 #include <drizzled/plugin.h>
+#include <drizzled/statistics_variables.h>
 #include "scoreboard.h"
 
 #include <math.h>

=== modified file 'plugin/logging_stats/stats_schema.cc'
--- plugin/logging_stats/stats_schema.cc	2011-02-17 00:14:13 +0000
+++ plugin/logging_stats/stats_schema.cc	2011-03-21 17:26:19 +0000
@@ -104,9 +104,8 @@
  */
 
 #include <config.h>
-
+#include <drizzled/statistics_variables.h>
 #include "stats_schema.h"
-
 #include <sstream>
 
 using namespace drizzled;

=== modified file 'plugin/memory/ha_heap.cc'
--- plugin/memory/ha_heap.cc	2011-03-18 16:04:10 +0000
+++ plugin/memory/ha_heap.cc	2011-03-21 17:26:19 +0000
@@ -22,6 +22,7 @@
 #include <drizzled/plugin/storage_engine.h>
 #include <drizzled/util/test.h>
 #include <drizzled/session/table_messages.h>
+#include <drizzled/statistics_variables.h>
 
 #include <boost/thread/mutex.hpp>
 

=== modified file 'plugin/multi_thread/multi_thread.cc'
--- plugin/multi_thread/multi_thread.cc	2011-03-15 21:30:35 +0000
+++ plugin/multi_thread/multi_thread.cc	2011-03-21 17:26:19 +0000
@@ -26,6 +26,7 @@
 #include <drizzled/transaction_services.h>
 #include <drizzled/gettext.h>
 #include <drizzled/plugin.h>
+#include <drizzled/statistics_variables.h>
 
 #include <boost/thread.hpp>
 #include <boost/bind.hpp>

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2011-03-18 16:04:10 +0000
+++ plugin/myisam/ha_myisam.cc	2011-03-21 17:26:19 +0000
@@ -36,6 +36,7 @@
 #include <drizzled/session/table_messages.h>
 #include <drizzled/plugin/storage_engine.h>
 #include <drizzled/key.h>
+#include <drizzled/statistics_variables.h>
 
 #include <boost/algorithm/string.hpp>
 #include <boost/scoped_ptr.hpp>

=== modified file 'plugin/mysql_protocol/net_serv.cc'
--- plugin/mysql_protocol/net_serv.cc	2011-02-22 04:19:44 +0000
+++ plugin/mysql_protocol/net_serv.cc	2011-03-21 17:26:19 +0000
@@ -23,6 +23,7 @@
 #include <drizzled/current_session.h>
 #include <drizzled/error.h>
 #include <drizzled/session.h>
+#include <drizzled/statistics_variables.h>
 
 #include <assert.h>
 #include <stdio.h>

